#include "minigui.ch"


Function MySQL_Logout()
   if Dbo != Nil
      Dbo:Destroy()
      Dbo := Nil
   EndIf
Return Nil



Function  MySQL_Connect()
   If Dbo != Nil
      Return Nil
   Endif
   Dbo := TMySQLServer():New(cHostName, cUser, cPassWord )
   If Dbo:NetErr()
      MsGInfo("Error connecting to SQL server: " + Dbo:Error() )
      Release Window ALL
      Quit
   Endif
return nil



Function DbExist(dbo, cDatabase)
   local aDbList := {}
   cDatabase := lower(cDatabase)
   aDbList := dbo:ListDbs()
   if dbo:neterr()
      msginfo("Error in varifying database list: "+dbo:error())
      return .f.
   endif
return (ascan(aDbList, {|x| lower(x) == lower(cDatabase)}) > 0)



Function TableExist(dbo, cTable)
   local aTableList := {}
   cTable = lower(cTable)
   aTableList := dbo:ListTables()
   if dbo:neterr()
      msginfo("Error in varifying table list: "+dbo:error())
      return .f.
   endif
return (ascan(aTableList, {|x| lower(x) == lower(cTable)}) > 0)



   //dbo is a public variable holding the database object
FUNCTION connect2db(host,user,password,dbname)
   dbo := tmysqlserver():new(AllTrim(host),AllTrim(user),AllTrim(password))
   IF dbo:NetErr()
      msginfo(dbo:ERROR())
      RETURN .f.
   ENDIF
   dbo:selectdb(dbname)
   IF dbo:NetErr()
      msginfo(dbo:ERROR())
      RETURN .f.
   ENDIF
   //msginfo("Successfully Connected to the MySQL Server")
RETURN .t.



function sql(dbo1,qstr)
   local i, j
   local table := nil
   local currow := nil
   local tablearr := {}
   local rowarr := {}
   local curdateformat := set(_SET_DATEFORMAT)
   set date ansi
   table := dbo1:query(qstr)
   if table:neterr()
      msgstop(table:error())
      table:destroy()
      set(_SET_DATEFORMAT,curdateformat)
      return tablearr
     
   else
      if table:lastrec() > 0
         asize(tablearr,0)
         for i := 1 to table:lastrec()
            asize(rowarr,0)
            currow := table:getrow(i)
            for j := 1 to table:fcount()
               aadd(rowarr,currow:fieldget(j))
               //msgbox(currow:fieldget(j))
            next j
            aadd(tablearr,aclone(rowarr))
         next i
      endif
      table:destroy()
      set(_SET_DATEFORMAT,curdateformat)
      return tablearr
   endif
return tablearr


function miscsql(dbo,qstr)
   local curdateformat := set( _SET_DATEFORMAT)
   set date ansi
   table := dbo:query(qstr)
   set( _SET_DATEFORMAT,curdateformat)
   if table:NetErr()
      msgstop(table:ERROR())
      table:destroy()
      return  .f.
   endif
   table:destroy()
return .t.



function C2SQL(Value)

   local cValue := ""
   local cFormatoDaData := set(4)
   do case
   case Valtype(Value) == "N"
      cValue := AllTrim(Str(Value))

   case Valtype(Value) == "D"
   	if !empty(Value)
   		//cValue := "'"+DTOS(value)+"'"
         cValue := "'"+Str(Year(Value), 4)  + "-" + PadL(Month(Value), 2, "0") + "-" + PadL(Day(Value), 2, "0") + "'"
   	else
   		cValue := "'00000000'"
   	endif
   case Valtype(Value) $ "CM"
      IF Empty( Value)
         cValue="''"
      ELSE
         cValue := "'"
         Value:=DATATOSQL(value)
         //Value := mysql_escape_string(Value)
         cValue+= value+ "'"
      ENDIF

   case Valtype(Value) == "L"
      cValue := AllTrim(Str(iif(Value == .F., 0, 1)))

   otherwise
      cValue := "''"                                // NOTE: Here we lose values we cannot convert

   endcase

   return cValue

   /*
   So, our insert query may be like this.
   qsuccess := miscsql(dbo,"insert into table1 (name, address1,city) values ("+c2sql(form1.name1.value)+","+c2sql(form1.address1.value)+","+c2sql(form1.city.value)+")")
*/


   /*
   Select query may be like this.
   tablearray := sql(dbo,"select * from table1 where city = "+c2sql(form1.city.value))	
*/	